"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.StringBuilder = void 0;
/**
 * Build a string from multiple substrings.
 */
class StringBuilder {
    /**
     * List of all substrings.
     */
    stringArray = [];
    /**
     * Append a new substring to the string builder.
     * @param { string } string Substring to append to the string builder.
     */
    append(string) {
        this.stringArray.push(string);
    }
    /**
     * Append a new sting with a new line feed to the string builder.
     * @param { string } string Substring to append with a new line feed to the string builder.
     */
    appendLine(string) {
        this.stringArray.push(`${string}\n`);
    }
    /**
     * Joins all substring to the result string.
     * @return { string } Result string of the string builder,
     */
    toString() {
        return this.stringArray.join('');
    }
}
exports.StringBuilder = StringBuilder;
